unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure ButtonMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  public
    { Public declarations }
  end;

  TMyButton = class(TButton)
               private
                dx,dy: integer;
               public
                procedure Mozdul;
              end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  a:array[1..10] of TMyButton;

procedure TMyButton.Mozdul;
begin
  if (Left+dx+30>Parent.ClientWidth) or (Left+dx<0) then dx:=-dx;
  if (Top+dy+30>Parent.ClientHeight) or (Top+dy<0) then dy:=-dy;
  Left:=Left+dx;
  Top:=Top+dy;
end;

procedure TForm1.ButtonMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
var i:integer;
begin
  for i:=1 to 10 do
    if a[i]=Sender then FreeAndNil(a[i]);
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
  randomize;
  for i:=1 to 10 do
   begin
   a[i] := TMyButton.Create(Self);
   a[i].Parent:=Self;
   a[i].Width:=30;
   a[i].Height:=30;
   a[i].Caption:='Click!';
   a[i].Left:=Random(Form1.ClientWidth-30);
   a[i].Top:=Random(Form1.ClientHeight-30);
   repeat
     a[i].dx:=random(3)-1;
     a[i].dy:=random(3)-1;
   until (a[i].dx<>0) or (a[i].dy<>0);
   a[i].OnMouseUp:=ButtonMouseUp;
   end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i:integer;
begin
  for i:=1 to 10 do
    if a[i]<>nil then a[i].Mozdul;
end;

end.
